//+------------------------------------------------------------------+
//|                                              BBwidth+SMA(50).mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link ""      

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 LimeGreen

//---- input parameters
extern int BB_period = 20;
extern int BB_std_deviation = 2;
extern int MA_period = 50;

//---- buffers
double ExtMapBuffer1[]; //BollingerBandWidth
double ExtMapBuffer2[]; //BandWidthSmoothing
double Upper_Band;
double Middle_Band;
double Lower_Band;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init() 
{
//---- BollingerBandWidth
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexDrawBegin(0, BB_period);

//---- BandWidthSmoothing 
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexDrawBegin(1, MA_period);
  
   return (0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
{
   return (0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start() 
{
   int limit; 
   int counted_bars=IndicatorCounted(); 
   if(counted_bars<0) return(-1); 
   if(counted_bars>0) counted_bars--; 
   limit=Bars-counted_bars; 
   for(int i=0; i<limit; i++) 
   {
//---- BollingerBand configuration
      Upper_Band  = iBands(Symbol(), 0, BB_period, BB_std_deviation, 0, PRICE_CLOSE, MODE_UPPER, i);
      Middle_Band = iBands(Symbol(), 0, BB_period, BB_std_deviation, 0, PRICE_CLOSE, MODE_BASE,  i);
      Lower_Band  = iBands(Symbol(), 0, BB_period, BB_std_deviation, 0, PRICE_CLOSE, MODE_LOWER, i);
      
//---- BollingerBandWidth configuration
      ExtMapBuffer1[i] = ((Upper_Band - Lower_Band) / Middle_Band) * 100.0;
      
//---- BandWidthSmoothing configuration      
      ExtMapBuffer2[i]=iMAOnArray(ExtMapBuffer1,0,MA_period ,0,MODE_SMA,i);
   }
   return (0);
}
//+------------------------------------------------------------------+